require "rd/rdfmt"
require "rd/rd2html-lib"

@rd_style_visitor = RD::RD2HTMLVisitor.new

@rd_style_visitor.instance_eval do
  @base_level = 1
end

def @rd_style_visitor.apply_to_DocumentElement(element, content)
  return content.join("")
end

def @rd_style_visitor.apply_to_Headline(element, title)
  anchor = get_anchor(element)
  label = hyphen_escape(element.label)
  return <<EOF
<h#{@base_level+element.level}><a name="#{anchor}" id="#{anchor}">#{title}</a>
</h#{@base_level+element.level}><!-- RDLabel: "#{label}" -->
EOF
end

def rd_style
end

def rd_style_filter
  if @fext != "rd"
    return
  end
  @title.sub!(/^=\s*/, "")
  src = []
  src.push("=begin\n")
  src += @body.to_a
  src.push("=end\n")
  tree = RD::Tree.new(RD::DocumentStructure::RD, src)
  tree.parse
  @body = @rd_style_visitor.visit(tree)
end
